#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;


const int maxn = (int) 3e5 + 100;
const int K = 26;

struct minLen
{
	static const int _inf = 1e9;
	int odd, even;
	minLen() : odd(_inf + 1), even(0) {}
	minLen(int _odd, int _even) : odd(_odd), even(_even) {}
	void relax(minLen oth)
	{
		odd = min(odd, oth.odd);
		even = min(even, oth.even);
	}
	minLen inf()
	{
		return minLen(_inf + 1, _inf);
	}
	minLen addOne()
	{
		return minLen(even + 1, odd + 1);
	}
};

struct Series
{
	int position;
	minLen value;
	Series() : position(), value() {}
	Series(int _position, minLen _value) : position(_position), value(_value) {}
};

minLen ans[maxn];

char str[maxn];
int suffLink[maxn];
int seriesLink[maxn];
Series series[maxn]; 
int p[maxn];
int to[maxn][K];
int len[maxn];
int numV;


int v;
vector <int> verticies;

void addLetter(int n)
{
	while (str[n] != str[n - len[v] - 1] )
		v = suffLink[v];
	int u = suffLink[v];
	while (str[n] != str[n - len[u] - 1] )
		u = suffLink[u];
	int u_ = to[u][ (int) str[n] ];
	int v_ = to[v][ (int) str[n] ];
	if (v_ == -1)
	{
		v_ = to[v][ (int) str[n] ] = numV++;
		len[v_] = len[v] + 2;
		suffLink[v_] = u_;

		p[v_] = len[v_] - len[u_];
		if (p[v_] == p[u_] )
			seriesLink[v_] = seriesLink[u_];
		else
			seriesLink[v_] = u_;
	}
	v = v_;
}

minLen getOr(int pos, int _v)
{
	return series[_v].value;
}

int getRound(int length, int period)
{
	int answer = length % period;
	if (answer == 0)
		answer = period;
	return answer;
}

// Jstress.cpp

minLen genSeries(int n, int _v)
{
	int u = suffLink[_v];
	minLen answer = ans[n - getRound(len[_v], p[_v] ) ].addOne();
//	fprintf(stderr, "set: _v = %d, n = %d\n", _v, n);
	if (3 * p[_v] <= len[_v] )
	{
		answer.relax(getOr(n - p[_v], u) );
	}
	else
	{
		if (2 * p[_v] <= len[_v] )
			answer.relax(ans[n - p[_v] - getRound(len[_v], p[_v] ) ].addOne() );
		answer.relax(ans[n - len[_v] ].addOne() );
	}
	series[_v] = Series(n, answer);
	return answer;
}

void init()
{
	memset(to, -1, sizeof to);
	numV = 2 + K;
	len[0] = -1;
	len[1] = 0;
	for (int i = 0; i < K; i++)
	{
		len[2 + i] = 1;
		suffLink[2 + i] = 1;
		to[0][i] = 2 + i;
		p[2 + i] = 1;
		seriesLink[2 + i] = 0;
	}
	suffLink[1] = 0;
}

int downEven(int len)
{
	if (len % 2 == 1)
		len--;
	return len;
}
int downOdd(int len)
{
	if (len % 2 == 0)
		len--;
	return len;
}

void printAns(minLen answer, int len)
{
	int cnt = 0;
	if (answer.odd > len)
		answer.odd = -1;
	else
		cnt++;
	if (answer.even > len)
		answer.even = -2;
	else
		cnt++;
	printf("%d %d\n", answer.odd, answer.even);
}

int main()
{
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
	init();

	printf("1 -2\n");

	str[0] = '#';
	scanf("%s", str + 1);
	
//	fprintf(stderr, "%s\n", str + 1);
	
	int n = strlen(str);
	v = 1;
	for (int i = 1; i < n; i++)
		str[i] -= 'a';
	for (int i = 1; i < n; i++)
	{
		addLetter(i);
		verticies.push_back(v);
	}
		
//	for (int i = 0; i < numV; i++)
//	{
//		fprintf(stderr, "%d: len = %d, suffLink = %d, serieLink = %d, p = %d\n", i, len[i], suffLink[i], seriesLink[i], p[i] );
//		for (int j = 0; j < K; j++)
//			fprintf(stderr, "to[%d] = %d, ", j, to[i][j] );
//		fprintf(stderr, "\n\n");
//	}


	for (int i = 1; i < n; i++)
	{
		ans[i] = minLen().inf();
		int _v = verticies[i - 1]; 
		if (len[_v] == i)
			ans[i].odd = 1;
		
		while (_v != 0)
		{
			ans[i].relax(genSeries(i, _v) );
			_v = seriesLink[_v];
		}
		if(i != 1)
		printAns(ans[i], i);
	}

	return 0;
}
