#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e6;
const int inf = (1 << 30) - 1;
const int CH = 26;

struct node {
	int suf, in, cnt, len, sum;
	node() {sum = suf = in = cnt = len = 0;}
} t[maxn];

int ans[3];
int T, n, vn, to[maxn][CH], q[maxn];
char s[maxn];

void read() {
	scanf("%s", s + 1);
	n = strlen(s + 1);
}


void prtab(int tab) {for (int i = 0; i < tab; i++) printf("\t");}
void show(int v, char ch, int tab) {
	prtab(tab);
	printf("[---> %c %d, ^link %d, cnt %d]\n", ch, v, t[v].suf, t[v].cnt);
	for (int i = 0; i < 26; ++i) {
		if (to[v][i] != -1) show(to[v][i], char('a' + i), tab + 1);
	}
}


void update(int head) {
	int l = 0, r = 0;
	for (int i = head; i < vn; i++) 
		if (t[i].in == 0) q[r++] = i;
	while (l < r) {
		int v = q[l++];
		int u = t[v].suf;
		t[u].cnt += t[v].cnt;
		t[u].in--;
		if (t[u].in == 0) q[r++] = u;
	}
}

int create(int v, int d) {
	t[v] = node();
	t[v].len = d;
	for (int i = 0; i < CH; i++)
		to[v][i] = -1;
	return v;
}

void go(int v) {
	t[v].sum++;
	for (int i = 0; i < 26; i++) 
		if (to[v][i] != -1) {
			go(to[v][i]);
			t[v].sum += t[to[v][i]].sum;
		}
}

int v;
void addLetter(int i, int head, int even) {
	int ch = s[i] - 'a';
	while (s[i] != s[i - t[v].len - 1]) v = t[v].suf;
	if (to[v][ch] != -1) {
		v = to[v][ch];
		t[v].cnt++;
		return;
	}
	int u = t[v].suf;
	while (s[i] != s[i - t[u].len - 1]) u = t[u].suf;
	u = (v == head ? even : to[u][ch]);
	v = to[v][ch] = create(vn++, t[v].len + 2);
	t[v].suf = u;
	t[v].cnt++;
	t[u].in++;
}

PII build() {
	int head = create(vn++, -1);
	t[head].suf = head;

	int even = create(vn++, 0);
	t[even].suf = head;
	v = head;
	for (int i = 1; i <= n; i++)
		addLetter(i, head, even);
	update(head);
	go(head); go(even);
	return PII(head, even);
}


void dfs(int v1, int v2, bool r = 1) {
	if (v1 == -1 && v2 == -1) return;
	if (v1 != -1 && v2 == -1) { ans[0] += t[v1].sum; return; }
	if (v1 == -1 && v2 != -1) { ans[2] += t[v2].sum; return; }
	if (r) {
		if (t[v1].cnt >  t[v2].cnt) ans[0]++;
		if (t[v1].cnt == t[v2].cnt) ans[1]++;
		if (t[v1].cnt <  t[v2].cnt) ans[2]++;
	}
	for (int i = 0; i < 26; i++)	
		dfs(to[v1][i], to[v2][i]);
}

int main()
{
	//freopen(fname"in", "r", stdin);
	//freopen(fname"out", "w", stdout);

	scanf("%d", &T);
	for (int q = 1; q <= T; q++) {
		ans[0] = ans[1] = ans[2] = vn = 0;
		read(); PII V1 = build();
		read(); PII V2 = build();
		dfs(V1.F, V2.F, 0);	
		dfs(V1.S, V2.S, 0);
		printf("Case #%d: %d %d %d\n", q, ans[0], ans[1], ans[2]);
	}


	return 0;
}



