#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const ll maxn = 35;
char letters[maxn + 1];

ll getBit(ll mask, ll bit) {
	return ((mask >> bit) & 1) != 0;
}

bool isOk(ll n, ll mask) {
	set < string > distinct;
	for(ll i = 0; i < n; i++) {
		letters[i] = getBit(mask, i) ? '0' : '1';
	}
	letters[n] = '\0';
	for(ll i = 0; i < n; i++) {
		for(ll d = -1; d <= 0; d++) {
			ll l = i, r = i + 1 + d;
			while(l >= 0 && r < n && letters[l] == letters[r]) {
				distinct.insert(string(letters[l], r - l + 1));
				--l;
				++r;
			}
		}
	}
	bool ok = distinct.size() == n;
	if(ok) {
		//cout << letters << endl;
	}
	return ok;
}

int main() {
	/*vector < ll > results(maxn + 1, 0);
	vector < ll > masks;
	masks.pb(0);
	masks.pb(1);
	for(ll len = 1; len <= maxn; len++) {
		vector < ll > new_masks;
		for(ll mask : masks) {
			if(isOk(len, mask)) {
				results[len] += 1;
				
			}
			new_masks.pb(mask | (ll(1) << len));
			new_masks.pb(mask);
		}
		sort(new_masks.begin(), new_masks.end());
		new_masks.erase(unique(new_masks.begin(), new_masks.end()), new_masks.end());
		masks.swap(new_masks);
		cout << "precalc[" << len << "] = " << results[len] << ";" << endl;
	}*/
	
	vector < ll > precalc(maxn + 1, 0);
	precalc[1] = 2;
	precalc[2] = 4;
	precalc[3] = 8;
	precalc[4] = 16;
	precalc[5] = 28;
	precalc[6] = 48;
	precalc[7] = 80;
	precalc[8] = 124;
	precalc[9] = 176;
	precalc[10] = 252;
	precalc[11] = 354;
	precalc[12] = 466;
	precalc[13] = 608;
	precalc[14] = 776;
	precalc[15] = 966;
	precalc[16] = 1218;
	precalc[17] = 1484;
	precalc[18] = 1772;
	precalc[19] = 2132;
	precalc[20] = 2534;
	precalc[21] = 2970;
	precalc[22] = 3470;
	precalc[23] = 4030;
	precalc[24] = 4624;
	precalc[25] = 5300;
	precalc[26] = 6050;
	precalc[27] = 6834;
	precalc[28] = 7728;
	precalc[29] = 8680;
	precalc[30] = 9676;
	precalc[31] = 10808;
	precalc[32] = 12022;
	precalc[33] = 13272;
	precalc[34] = 14632;
	precalc[35] = 16126;
	ll n;
	cin >> n;
	for(ll i = 1; i <= n; i++)
		cout << precalc[i] << endl;
	return 0;
}