#include <iostream>

#define S_LENGTH 200010
#define LETTERS_CNT 27
typedef unsigned long long ull;

using namespace std;

struct Node
{
	int len;
	int suffix_link;
	int cnt;
	int next[LETTERS_CNT];

	Node():len(0),suffix_link(0),cnt(0)
	{
		for(int i = 0; i < LETTERS_CNT; i++)
			next[i] = 0;
	}
};

char s[S_LENGTH];

Node tree[2][S_LENGTH];

int max_suffix, tree_length;
int pos;
ull f1, f2, f3;

void init_tree(int tree_index)
{
	tree[tree_index][1] = Node();
	tree[tree_index][2] = Node();

	max_suffix = 2;
	tree_length = 2;

	tree[tree_index][1].len = -1;
	tree[tree_index][1].suffix_link = 1;

	tree[tree_index][2].len = 0;
	tree[tree_index][2].suffix_link = 1;
}

void add_letter(int tree_index)
{
	//cerr << "adding letter " << s[pos] << endl;
	int letter = s[pos] - 'a';

	int cur_suffix = max_suffix;
	int cur_length = tree[tree_index][cur_suffix].len;

	while(true)
	{
		//cerr << "i am at " << cur_suffix << endl;
		if(pos - cur_length - 1 >= 0 && s[pos - cur_length - 1] == s[pos])
			break;
		cur_suffix = tree[tree_index][cur_suffix].suffix_link;
		cur_length = tree[tree_index][cur_suffix].len;
	}

	if(tree[tree_index][cur_suffix].next[letter] != 0)
	{
		tree[tree_index][tree[tree_index][cur_suffix].next[letter]].cnt++;
		return;
	}

	tree_length++;
	tree[tree_index][tree_length] = Node();
	tree[tree_index][cur_suffix].next[letter] = tree_length;
	tree[tree_index][tree_length].len = tree[tree_index][cur_suffix].len + 2;
	tree[tree_index][tree_length].cnt = 1;
	max_suffix = tree_length;

	if(tree[tree_index][tree_length].len == 1)
	{
		tree[tree_index][tree_length].suffix_link = 2;
		//cerr << "node added id = " << tree_length << "; suffix_link = " << tree[tree_index][tree_length].suffix_link << endl;
		//cerr << "now max_suffix = " << max_suffix << endl;
		return;
	}

	cur_suffix = tree[tree_index][cur_suffix].suffix_link;
	cur_length = tree[tree_index][cur_suffix].len;

	while(true)
	{
		if(pos - cur_length - 1 >= 0 && s[pos - cur_length - 1] == s[pos])
			break;
		cur_suffix = tree[tree_index][cur_suffix].suffix_link;
		cur_length = tree[tree_index][cur_suffix].len;
	}

	tree[tree_index][tree_length].suffix_link = tree[tree_index][cur_suffix].next[letter];

	//cerr << "node added id = " << tree_length << "; suffix_link = " << tree[tree_index][tree_length].suffix_link << endl;
}

void dfs_single(int tree_index, int v, ull& f)
{
	//cerr << "found palindrome " << v << " in tree" << tree_index + 1 << endl;
	//cerr << "cnt" << tree_index+1 << " = " << tree[tree_index][v].cnt << endl;
	if(v > 2)
		f++;

	for(int l = 0; l < LETTERS_CNT; l++)
	{
		if(tree[tree_index][v].next[l] != 0)
			dfs_single(tree_index, tree[tree_index][v].next[l], f);
	}
}

void dfs(int v1, int v2)
{
	//cerr << "found palindrome " << v1 << " in tree1 and " << v2 << " in tree2\n";
	//cerr << "cnt1 = " << tree[0][v1].cnt << "; cnt2 = " << tree[1][v2].cnt << endl;
	if(v1 > 2 && v2 > 2)
		if(tree[0][v1].cnt > tree[1][v2].cnt)
			f1++;
		else if((tree[0][v1].cnt == tree[1][v2].cnt) && tree[0][v1].cnt != 0)
			f2++;
		else if(tree[0][v1].cnt < tree[1][v2].cnt)
			f3++;

	for(int l = 0; l < LETTERS_CNT; l++)
	{
		if(tree[0][v1].next[l] != 0 && tree[1][v2].next[l] != 0)
			dfs(tree[0][v1].next[l], tree[1][v2].next[l]);
		else if(tree[0][v1].next[l] != 0 && tree[1][v2].next[l] == 0)
			dfs_single(0, tree[0][v1].next[l], f1);
		else if(tree[0][v1].next[l] == 0 && tree[1][v2].next[l] != 0)
			dfs_single(1, tree[1][v2].next[l], f3);
	}
}

void process_tree(int tree_index)
{
	cin >> s;
	init_tree(tree_index);
	for(pos = 0; s[pos] != 0; pos++)
		add_letter(tree_index);

	//cerr << "tree length is " << tree_length << endl;

	for(int i = tree_length; i > 2; i--)
		tree[tree_index][tree[tree_index][i].suffix_link].cnt += tree[tree_index][i].cnt;
}

void solve(int testnum)
{
	process_tree(0);
	process_tree(1);
	f1 = 0; f2 = 0; f3 = 0;
	dfs(1, 1);
	dfs(2, 2);
	cout << "Case #" << testnum << ": " << f1 << ' ' << f2 << ' ' << f3 << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve(i+1);
	//cin >> t;
}