#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

const int kMaxN = 3e5 + 10;
const int kMaxC = 26;

struct Node
{
    int next[kMaxC];

    int amount;
    int suff_link;
    int len;
};

Node tree[kMaxN];
int max_suff_id;
int tree_size;

int n;

string s;

void Init()
{
    for (int i = 0; i < kMaxN; ++i) {
        for (int j = 0; j < kMaxC; ++j) {
            tree[i].next[j] = 0;
        }
    }
    tree_size = 2;

    tree[1].amount = 0;
    tree[1].suff_link = 1;
    tree[1].len = -1;

    tree[2].amount = 0;
    tree[2].suff_link = 1;
    tree[2].len = 0;

    max_suff_id = 2;
}

bool AddLetter(int pos)
{
    int letter = s[pos] - 'a';

    int cur_suff = max_suff_id;
    int cur_len = tree[cur_suff].len;

    while (true) {
        if (pos - cur_len - 1 >= 0 && s[pos - cur_len - 1] == s[pos]) {
            break;
        }

        cur_suff = tree[cur_suff].suff_link;
        cur_len = tree[cur_suff].len;
    }

    if (tree[cur_suff].next[letter]) {
        max_suff_id = cur_suff;
        return false;
    }

    ++tree_size;
    tree[cur_suff].next[letter] = tree_size;
    tree[tree_size].len = cur_len + 2;

    max_suff_id = tree_size;

    if (cur_suff == 1) {
        tree[tree_size].suff_link = 2;
        tree[tree_size].amount = 1;
        return true;
    }

    while (true) {
        cur_suff = tree[cur_suff].suff_link;
        cur_len = tree[cur_suff].len;
        if (pos - cur_len - 1 >= 0 && s[pos - cur_len - 1] == s[pos]) {
            break;
        }
    }

    tree[tree_size].suff_link = tree[cur_suff].next[letter];
    tree[tree_size].amount = tree[tree[tree_size].suff_link].amount + 1;

    return true;
}

vector<int> GetPalindromesAtPos()
{
    vector<int> result(n);

    Init();

    for (int i = 0; i < n; ++i) {
        AddLetter(i);
        result[i] = tree[max_suff_id].amount;
    }

    return result;
}

int main()
{
    ios_base::sync_with_stdio(false);

    cin >> s;
    n = s.length();

    vector<int> e = GetPalindromesAtPos();

    reverse(s.begin(), s.end());

    vector<int> b = GetPalindromesAtPos();

    reverse(b.begin(), b.end());

    long long answer = 0;

    for (int i = 0; i + 1 < n; ++i) {
        answer += 1LL * e[i] * b[i + 1];
    }

    cout << answer << endl;

    return 0;
}
