#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>
#define pb push_back

const int alpha = 26;

struct Node
{
	int len;
	int link;
	int next[alpha];
	int path_len;
	Node(int _len, int _link) : len(_len), link(_link), path_len(0)
	{
		forn(j, alpha)
			next[j] = -1;
	}
};

vector <Node> tree[2];
vi endings[2];

void build(string & s, int number)
{
	endings[number].resize(s.length());
	forn(j, s.length())
		s[j] -= 'a';
	tree[number].pb(Node(0, 1));
	tree[number].pb(Node(-1, 1));
	int cur = 0;
	forn(j, s.length())
	{
		int letter = s[j];
		//while(cur > 1 && (j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1]))
		while((j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1]))
		//while(j - tree[number][cur].len - 1 < 0 || letter != s[j - tree[number][cur].len - 1])
			cur = tree[number][cur].link;
		if (tree[number][cur].next[letter] == -1)
		{
			tree[number].pb(Node(tree[number][cur].len + 2, -1));
			
			//int new_link = cur;
			if (cur == 1)
			{
				tree[number][tree[number].size() - 1].link = 0;
				tree[number][tree[number].size() - 1].path_len = 1;
			}
			else
			{
				int new_link = tree[number][cur].link;
				//while(new_link > 1 && letter != s[j - tree[number][new_link].len - 1])
				//while( new_link > 1 && (j - tree[number][new_link].len - 1 < 0 || letter != s[j - tree[number][new_link].len - 1]))
				
				while((j - tree[number][new_link].len - 1 < 0 || letter != s[j - tree[number][new_link].len - 1]))
					new_link = tree[number][new_link].link;
				int L = tree[number][new_link].next[letter];
				tree[number][tree[number].size() - 1].link = L; 
				tree[number][tree[number].size() - 1].path_len = tree[number][L].path_len + 1;
			}
			tree[number][cur].next[letter] = tree[number].size() - 1;
			cur = tree[number].size() - 1;
		}
		else
		{
			cur = tree[number][cur].next[letter];
		}
		endings[number][j] = tree[number][cur].path_len;
	}
	/*forn(j, tree[number].size())
	{
		printf("j = %d\n", j);
		printf("len = %d link = %d cnt = %lld\n", tree[number][j].len, tree[number][j].link, tree[number][j].cnt);
		forn(i, alpha) if (tree[number][j].next[i] != -1)
			printf("next[%d] = %d\n", i, tree[number][j].next[i]);
	}
	printf("======================\n");*/
}



void solve()
{
	tree[0].clear();
	tree[1].clear();
	string s1, s0;
	cin >> s0;
	s1 = "";
	for (int j = s0.length() - 1; j >= 0; j--)
		s1 += s0[j];
	build(s0, 0);
	
	build(s1, 1);
	i64 answer = 0;
	forn(pos, s0.length() - 1)
		answer += (i64)endings[0][pos] * (i64)endings[1][s0.length() - pos - 2];
	printf("%lld", answer);
	
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	solve();
}