#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 500100;

#define link slhfdskfh_link

int to[MAXN][26];
int link[MAXN];
int len[MAXN];
int num;
ll cnt[2][MAXN];
char s[2][MAXN];

void
clear(int v)
{
	link[v] = 0;
	len[v] = 0;
	for (int i = 0; i < 26; ++i) {
		to[v][i] = 0;
	}
	cnt[0][v] = cnt[1][v] = 0;
}

void
init()
{
	num = 2;
	clear(1);
	clear(2);
	link[1] = link[2] = 1;
	len[1] = -1;
	len[2] = 0;
}

void
add(char *s, int mlen, int id)
{
	int curId = 2;
	for (int i = 0; i < mlen; ++i) {
		while (i - len[curId] - 1 < 0 || s[i - len[curId] - 1] != s[i]) {
			curId = link[curId];
		}
		if (to[curId][s[i] - 'a'] == 0) {
			++num;
			to[curId][s[i] - 'a'] = num;
			clear(num);
			len[num] = len[curId] + 2;
			int secondId = link[curId];
			while (i - len[secondId] - 1 < 0 || s[i - len[secondId] - 1] != s[i]) {
				secondId = link[secondId];
			}
			if (to[secondId][s[i] - 'a'] == 0) {
				++num;
				to[secondId][s[i] - 'a'] = num;
				clear(num);
				len[num] = len[secondId] + 2;
			}
			secondId = to[secondId][s[i] - 'a'];
			curId = to[curId][s[i] - 'a'];
			link[curId] = secondId;
			if (curId == secondId) {
				link[curId] = 2;
			}
		} else {
			curId = to[curId][s[i] - 'a'];
		}
		cnt[id][curId]++;
	}
}

void
process(int tid)
{
	init();
	for (int i = 0; i < 2; ++i) {
		scanf(" %s", s[i]);
		add(s[i], strlen(s[i]), i);
	}
	for (int i = 0; i < 2; ++i) {
		for (int dd = num; dd > 0; --dd) {
			cnt[i][link[dd]] += cnt[i][dd];
		}
	}
	int cnt1 = 0, cnt2 = 0, cnt3 = 0;
	for (int i = 1; i <= num; ++i) {
		if (len[i] > 0) {
			if (cnt[0][i] == cnt[1][i]) {
				++cnt2;
			} else if (cnt[0][i] > cnt[1][i]) {
				++cnt1;
			} else {
				++cnt3;
			}
		}
	}
	printf("Case #%d: %d %d %d\n", tid, cnt1, cnt2, cnt3);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process(i + 1);
	}

	return 0;
}