#pragma comment(linker, "/STACK:256000000")

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 66;
const int P = 30;

struct node {

	int odd;
	int len, link;
	int next[2];

};

int sz, cur;
char s[N];
node v[N];
vector<pair<int*, int> > changes;
ll ans[P + 10];

inline void init() {
	sz = 2;
	for (int i = 0; i < 2; ++i) {
		v[0].next[i] = v[1].next[i] = -1;
	}
	v[0].odd = true;
	v[1].link = 0;
	cur = 0;
}

inline void change(int *a, int b) {
	changes.pb(mp(a, *a));
	*a = b;
}

inline bool add(int pos) {
	for (;;) {
		if (v[cur].odd) {
			if (pos - 2 * v[cur].len >= 0 && s[pos] == s[pos - 2 * v[cur].len]) {
				break;
			}
		} else {
			if (pos - 2 * v[cur].len - 1 >= 0 && s[pos] == s[pos - 2 * v[cur].len - 1]) {
				break;
			}
		}
		change(&cur, v[cur].link);
	}
	if (v[cur].next[s[pos]] != -1) {
		change(&cur, v[cur].next[s[pos]]);
		return false;
	}
	change(&v[cur].next[s[pos]], sz);
	for (int i = 0; i < 2; ++i) {
		v[sz].next[i] = -1;
	}
	v[sz].odd = v[cur].odd;
	v[sz].len = v[cur].len + 1;
	if (cur == 0) {
		v[sz].link = 1;
	} else {
		int ver = v[cur].link;
		for (;;) {
			if (v[ver].odd) {
				if (pos - 2 * v[ver].len >= 0 && s[pos] == s[pos - 2 * v[ver].len]) {
					break;
				}
			} else {
				if (pos - 2 * v[ver].len - 1 >= 0 && s[pos] == s[pos - 2 * v[ver].len - 1]) {
					break;
				}
			}
			ver = v[ver].link;
		}
		ver = v[ver].next[s[pos]];
		v[sz].link = ver;
	}
	change(&cur, sz);
	change(&sz, sz + 1);
	assert(sz <= P + 2);
	return true;
}

void gen(int x) {
	++ans[x];
	if (x == P) {
		return;
	}
	for (int i = 0; i < 2; ++i) {
		int sz = sz(changes);
		s[x] = i;
		if (add(x)) {
			gen(x + 1);
		}
		while (sz(changes) > sz) {
			*changes.back().fs = changes.back().sc;
			changes.pop_back();
		}
	}
}

ll fans[] = {2,4,8,16,32,64,128,252,488,932,1756,3246,5916,10618,18800,32846,56704,96702,163184,272460,450586,738274,1199376,1932338,3089518,4903164,7728120,12099440,18825066,29112876,};

int main() {
#ifdef LOCAL42
#define TASK "E"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	/*init();
	gen(0);
	cout << "ll fans[] = {";
	for (int i = 1; i <= P; ++i) {
		cout << ans[i] << ",";
	}
	cout << "};";*/
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cout << fans[i] << endl;
	}
	return 0;
}
