#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(2e5) + 100;

struct node {

	bool odd;
	int len, cnt1, cnt2, link;
	int next[27];

};

int sz, cur;
char s[2 * N], t[N];
node v[2 * N];

inline void init() {
	sz = 2;
	for (int i = 0; i < 27; ++i) {
		v[0].next[i] = v[1].next[i] = -1;
	}
	v[0].odd = true;
	v[1].link = 0;
	cur = 0;
	v[0].cnt1 = v[0].cnt2 = 0;
	v[1].cnt1 = v[1].cnt2 = 0;
}

inline void add(int pos) {
	for (;;) {
		if (v[cur].odd) {
			if (pos - 2 * v[cur].len >= 0 && s[pos] == s[pos - 2 * v[cur].len]) {
				break;
			}
		} else {
			if (pos - 2 * v[cur].len - 1 >= 0 && s[pos] == s[pos - 2 * v[cur].len - 1]) {
				break;
			}
		}
		cur = v[cur].link;
	}
	if (v[cur].next[s[pos] - 'a'] != -1) {
		cur = v[cur].next[s[pos] - 'a'];
		return;
	}
	v[cur].next[s[pos] - 'a'] = sz;
	for (int i = 0; i < 27; ++i) {
		v[sz].next[i] = -1;
	}
	v[sz].cnt1 = v[sz].cnt2 = 0;
	v[sz].odd = v[cur].odd;
	v[sz].len = v[cur].len + 1;
	if (cur == 0) {
		v[sz].link = 1;
	} else {
		cur = v[cur].link;
		for (;;) {
			if (v[cur].odd) {
				if (pos - 2 * v[cur].len >= 0 && s[pos] == s[pos - 2 * v[cur].len]) {
					break;
				}
			} else {
				if (pos - 2 * v[cur].len - 1 >= 0 && s[pos] == s[pos - 2 * v[cur].len - 1]) {
					break;
				}
			}
			cur = v[cur].link;
		}
		cur = v[cur].next[s[pos] - 'a'];
		v[sz].link = cur;
	}
	cur = sz++;
}

inline void solve() {
	gets(s);
	gets(t);
	int n = strlen(s), m = strlen(t);
	int mem_n = n;
	s[n++] = 'z' + 1;
	for (int i = 0; i < m; ++i) {
		s[n++] = t[i];
	}
	init();
	for (int i = 0; i < n; ++i) {
		add(i);
		if (i < mem_n) {
			++v[cur].cnt1;
		}
		if (i > mem_n) {
			++v[cur].cnt2;
		}
	}
	for (int i = sz - 1; i >= 2; --i) {
		v[v[i].link].cnt1 += v[i].cnt1;
		v[v[i].link].cnt2 += v[i].cnt2;
	}
	int a = 0, b = 0, c = 0;
	for (int i = 2; i < sz; ++i) {
		if (v[i].cnt1 > v[i].cnt2) {
			++a;
		}
		if (v[i].cnt1 > 0 && v[i].cnt1 == v[i].cnt2) {
			++b;
		}
		if (v[i].cnt1 < v[i].cnt2) {
			++c;
		}
	}
	printf("%d %d %d\n", a, b, c);
}

int main() {
#ifdef LOCAL42
#define TASK "D"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	gets(s);
	for (int i = 0; i < t; ++i) {
		printf("Case #%d: ", i + 1);
		solve();
	}
	return 0;
}
