#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int kN = 300 * 1000 + 10;
char s[kN];
int odd[kN];
int even[kN];

void Compute() {
  int n = strlen(s);
  odd[0] = 1;
  int l = 0, r = 0;
  for (int i = 1; s[i]; ++i) {
    int k = 0;
    if (i <= r)
      k = min(r - i + 1, odd[l + r - i]);
    for (; i - k >= 0 && i + k < n && s[i + k] == s[i - k]; ++k) {}
    odd[i] = k;
    if (i + k - 1 > r) {
      l = i - k + 1; r = i + k - 1;
    }
  }
  l = -1, r = -1;
  for (int i = 0; s[i]; ++i) {
    int k = 0;
    if (i <= r)
      k = min(r - i, even[l + r - i - 1]);
    for (; i - k >= 0 && i + k + 1 < n && s[i + k + 1] == s[i - k]; ++k) {}
    even[i] = k;
    if (i + k > r) {
      l = i - k + 1; r = i + k;
    }
  } 
}

LL sumL[kN];
LL sumR[kN];

int main() {
  scanf("%s", s);
  Compute();
  int n = strlen(s);
  FOR(i, 0, n) {
    sumR[i - odd[i] + 1]++;
    sumR[i + 1]--;
    sumL[i]++;
    sumL[i + odd[i]]--;
    sumR[i - even[i] + 1]++;
    sumR[i + 1]--;
    sumL[i + 1]++;
    sumL[i + even[i] + 1]--;
  }
  LL answer = 0;
  FOR(i, 0, n - 1) {
    sumL[i + 1] += sumL[i];
    sumR[i + 1] += sumR[i];

    answer += LL(sumL[i]) * LL(sumR[i + 1]);
  }
  printf("%lld", answer);
  return 0;
}
