#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

struct Node {
  int next[26];
  int cnt[2];
  int len;
  int suff;

  Node() {
    memset(next, 255, sizeof(next));
    memset(cnt, 0, sizeof(cnt));
  }
};

const int kN = 500 * 1000 + 10;
Node tree[kN];
char s[kN];
int ind;

int size;
int suff;

void Add(int pos) {
  int curr = suff;
  while (true) {
    int len = tree[curr].len;
    if (s[pos] == s[pos - len - 1]) {
      break;
    }
    curr = tree[curr].suff;
  }
  int ch = s[pos] - 'a';
  if (tree[curr].next[ch] != -1) {
    int nxt = tree[curr].next[ch];
    ++tree[nxt].cnt[ind];
    suff = nxt;
    return;  
  }
  tree[curr].next[ch] = size;
  tree[size].len = tree[curr].len + 2;
  tree[size].cnt[ind] = 1;
  suff = size;
  if (tree[size].len == 1) {
    tree[size].suff = 1;
    ++size;
    return;    
  }
  while (true) {
    curr = tree[curr].suff;
    int len = tree[curr].len;
    if (s[pos] == s[pos - len - 1]) {
      break;
    }
  }
  tree[size].suff = tree[curr].next[ch];
  ++size;
}

void Init() {
  for (int i = 0; i < size; ++i) {
    tree[i] = Node();
  }

  tree[0].len = -1; tree[0].suff = 0;
  tree[1].len = 0; tree[1].suff = 0;
  size = 2;
}

int main() {
  int T;
  scanf("%d", &T);
  Init();
  for (int t = 0; t < T; ++t) {
    scanf("%s", s);
    ind = 0;
    suff = 1;
    for (int i = 0; s[i]; ++i)
      Add(i);
    scanf("%s", s);
    ind = 1;
    suff = 1;
    for (int i = 0;  s[i]; ++i)
      Add(i);
    for (int i = size - 1; i >= 2; --i) {
      tree[tree[i].suff].cnt[0] += tree[i].cnt[0];
      tree[tree[i].suff].cnt[1] += tree[i].cnt[1];
    }
    int res0 = 0, res1 = 0, res2 = 0;
    for (int i = 2; i < size; ++i) {
      if (tree[i].cnt[0] > tree[i].cnt[1]) {
        ++res0;
      } else if (tree[i].cnt[0] == tree[i].cnt[1]) {
        ++res1;
      } else if (tree[i].cnt[0] < tree[i].cnt[1]) {
        ++res2;
      }
    }
    printf("Case #%d: %d %d %d\n", t + 1, res0, res1, res2);
    Init();
  }
  return 0;
}
