#include <iostream>
#include <string>
#include <bitset>

using namespace std;

const int SIGMA = 2;

struct Node {
    int go[SIGMA], len, link;
};

const int MAXN = 100;
Node pt[MAXN];
int freeNode, suff;
const int N = 26, POWN = (1 << N);
int ans[] = {2, 4, 8, 16, 32, 64, 128, 252, 488, 932, 1756, 3246, 5916, 10618, 18800, 32846,
56704, 96702, 163184, 272460, 450586, 738274, 1199376, 1932338, 3089518, 4903164, 7728120, 12099440, 18825066, 29112876};
bitset<POWN> bs;

int newNode(int len, int link) {
    for(int i = 0; i < SIGMA; i++)
        pt[freeNode].go[i] = -1;
    pt[freeNode].len = len;
    pt[freeNode].link = link;
    return freeNode++;
}

void add(int pos, string &s) {
    while(pos - pt[suff].len - 1 < 0 || s[pos - pt[suff].len - 1] != s[pos])
        suff = pt[suff].link;
    if(pt[suff].go[s[pos] - 'a'] == -1) {
        int link = pt[suff].link;
        while(pos - pt[link].len - 1 < 0 || s[pos - pt[link].len - 1] != s[pos])
            link = pt[link].link;
        link = max(1, pt[link].go[s[pos] - 'a']);
        pt[suff].go[s[pos] - 'a'] = newNode(pt[suff].len + 2, link);
    }
    suff = pt[suff].go[s[pos] - 'a'];
}

bool ok(long long msk, int len) {
    string s;
    for(int i = 0; i < len; i++)
        s += char('a' + (bool)(msk & (1ll << i)));
    freeNode = 0;
    suff = 0;
    newNode(-1, 0);
    newNode(0, 0);
    for(int i = 0; i < len; i++)
        add(i, s);
    return freeNode - 2 == len;
}

void getBs() {
    for(int msk = 0; msk < POWN; msk++)
        bs[msk] = ok(msk, N);
}

void solve(int l, int r) {
    for(int i = l; i <= r; i++) {
        long long ans = 0;
        for(long long msk = 0; msk < (1ll << i); msk++) {
            if(!bs[msk >> (i - N)]) {
                msk += (1ll << (i - N)) - 1;
                continue;
            }
            ans += ok(msk, i);
        }
        cout << ans << ", ";
        cout.flush();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    //getBs();
    //solve(27, 30);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cout << ans[i] << '\n';
    return 0;
}
