#include <iostream>
#include <string>

using namespace std;

const int SIGMA = 26;

struct Node {
    int go[SIGMA], len, link, a, b;
};

const int MAXN = 400 * 1000 + 5;
Node pt[MAXN];
int freeNode, suff;

int newNode(int len, int link) {
    for(int i = 0; i < SIGMA; i++)
        pt[freeNode].go[i] = -1;
    pt[freeNode].len = len;
    pt[freeNode].link = link;
    pt[freeNode].a = 0;
    pt[freeNode].b = 0;
    return freeNode++;
}

void add(int pos, string &s, bool b) {
    while(pos - pt[suff].len - 1 < 0 || s[pos - pt[suff].len - 1] != s[pos])
        suff = pt[suff].link;
    if(pt[suff].go[s[pos] - 'a'] == -1) {
        int link = pt[suff].link;
        while(pos - pt[link].len - 1 < 0 || s[pos - pt[link].len - 1] != s[pos])
            link = pt[link].link;
        link = max(1, pt[link].go[s[pos] - 'a']);
        pt[suff].go[s[pos] - 'a'] = newNode(pt[suff].len + 2, link);
    }
    suff = pt[suff].go[s[pos] - 'a'];
    if(b)
        pt[suff].b++;
    else
        pt[suff].a++;
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        freeNode = 0;
        suff = 0;
        newNode(-1, 0);
        newNode(0, 0);
        string a, b;
        cin >> a >> b;
        for(size_t i = 0; i < a.length(); i++)
            add(i, a, false);
        suff = 0;
        for(size_t i = 0; i < b.length(); i++)
            add(i, b, true);
        for(int i = freeNode - 1; i > 1; i--) {
            pt[pt[i].link].a += pt[i].a;
            pt[pt[i].link].b += pt[i].b;
        }
        int x = 0, y = 0, z = 0;
        for(int i = 2; i < freeNode; i++)
            if(pt[i].a > pt[i].b)
                x++;
            else if(pt[i].a == pt[i].b)
                y++;
            else
                z++;
        cout << "Case #" << tt + 1 << ": " << x << ' ' << y << ' ' << z << '\n';
    }
    return 0;
}
