#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 9;

struct node {
	int next[26];
	int len;
	int sufflink;
};

node tree[maxn];
string s;
int suff;
int num;

void initTree() {
	num = suff = 2;
	tree[1].len = -1;
	tree[1].sufflink = 1;
	tree[2].len = 0;
	tree[2].sufflink = 1;
}

void addLetter(int pos) {
	int letter = s[pos] - 'a';
	int curlen = 0;
	int cur = suff;

	while (1) {
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] ==s[pos]))
			break;
		cur = tree[cur].sufflink;
	}

	if (tree[cur].next[letter]) {
		suff = tree[cur].next[letter];
		return;
	}

	num++;
	suff = num;
	tree[num].len = tree[cur].len + 2;
	tree[cur].next[letter] = num;

	if (tree[num].len == 1) {
		tree[num].sufflink = 2;
		return;
	}

	while (1) {
		cur = tree[cur].sufflink;
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] == s[pos])) {
			tree[num].sufflink = tree[cur].next[letter];
			break;
		}
	}
}


int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
		printf("%lld\n", 1LL << i);
	return 0;
}