#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 9;

struct node {
	int next[26];
	int len;
	int sufflink;

	int numa, numb;
	int lazya, lazyb;
};

node tree[maxn];
string s;
int suff;
int num;

void initTree() {
	for (int i = 0; i < maxn; i++) 
		tree[i] = node();

	num = suff = 2;
	tree[1].len = -1;
	tree[1].sufflink = 1;
	tree[2].len = 0;
	tree[2].sufflink = 1;
}

int ss;
vector <int> used;

void addLetter(int pos) {
	int letter = s[pos] - 'a';
	int curlen = 0;
	int cur = suff;

	while (1) {
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] == s[pos]))
			break;
		cur = tree[cur].sufflink;
	}

	if (tree[cur].next[letter]) {
		suff = tree[cur].next[letter];
		if (ss == 1) {
			tree[suff].numa++;
			tree[suff].lazya++;
		}
		else  {		
			tree[suff].numb++;
			tree[suff].lazyb++;
		}
		return;
	}

	num++;
	suff = num;
	tree[num].len = tree[cur].len + 2;
	tree[cur].next[letter] = num;

	if (tree[num].len == 1) {
		tree[num].sufflink = 2;
		if (ss == 1)
			tree[num].numa = 1;
		else
			tree[num].numb = 1;
		return;
	}

	while (1) {
		cur = tree[cur].sufflink;
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] == s[pos])) {
			tree[num].sufflink = tree[cur].next[letter];
			used[tree[cur].next[letter]] = true;
			break;
		}
	}
	if (ss == 1) {
		tree[num].numa = 1;
		tree[num].lazya++;
	}
	else  {		
		tree[num].numb = 1;
		tree[num].lazyb++;
	}

}

int cntb, cnte, cntl;

void dfs(int v) {
	if ((v != 2) && (v != 1)) {
		if (tree[v].numa > tree[v].numb)
			cntb++;
		else if (tree[v].numa < tree[v].numb)
			cntl++;
		else
			cnte++;
	}
	for (int i = 0; i < 26; i++) {
		if(tree[v].next[i])
			dfs(tree[v].next[i]);
	}
}

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	getchar();
	for (int i = 0; i < t; i++) {
		string s1;
		string s2;

		initTree();
		used.assign(maxn, false);

		used[2] = true;
		used[1] = true;

		getline(cin, s1);
		ss = 1;
		s = s1;
		for (int j = 0; j < sz(s1); j++) {
			addLetter(j);
		}

		getline(cin, s2);
		ss = 2;
		s = s2;
		for (int j = 0; j < sz(s2); j++)
			addLetter(j);

		for (int j = sz(s1) + 3; j >= 3; j--) {
			if(used[j])
				continue;
			int cur = j;
			int plus = tree[j].lazya;
			tree[j].lazya = 0;
			cur = tree[cur].sufflink;
			while (cur > 2) {
				tree[cur].numa += plus;
				plus += tree[cur].lazya;
				tree[cur].lazya = 0;
				cur = tree[cur].sufflink;
			}
		}
		for (int j = sz(s2) + 3; j >= 3; j--) {
			if(used[j])
				continue;
			int cur = j;
			int plus = tree[j].lazyb;
			tree[j].lazyb = 0;
			cur = tree[cur].sufflink;
			while (cur > 2) {
				tree[cur].numb += plus;
				plus += tree[cur].lazyb;
				tree[cur].lazyb = 0;
				cur = tree[cur].sufflink;
			}
		}

		cntb = cnte = cntl = 0;
		dfs(1);
		dfs(2);
		printf("Case #%d: %d %d %d\n", i + 1, cntb, cnte, cntl);
	}
	return 0;
}