#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 9;

struct node {
	int next[26];
	int len;
	int sufflink;

	int numa, numb;
	int lazya, lazyb;
};

node tree[maxn];
string s;
int suff;
int num;

void initTree(int N) {
	for (int i = 0; i < N; i++) 
		tree[i] = node();

	num = suff = 2;
	tree[1].len = -1;
	tree[1].sufflink = 1;
	tree[2].len = 0;
	tree[2].sufflink = 1;
}

int ss;

void addLetter(int pos) {
	int letter = s[pos] - 'a';
	int curlen = 0;
	int cur = suff;

	while (1) {
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] == s[pos]))
			break;
		cur = tree[cur].sufflink;
	}

	if (tree[cur].next[letter]) {
		suff = tree[cur].next[letter];
		if (ss == 1) {
			tree[suff].numa++;
			tree[suff].lazya++;
		}
		else  {		
			tree[suff].numb++;
			tree[suff].lazyb++;
		}
		return;
	}

	num++;
	suff = num;
	tree[num].len = tree[cur].len + 2;
	tree[cur].next[letter] = num;

	if (tree[num].len == 1) {
		tree[num].sufflink = 2;
		if (ss == 1)
			tree[num].numa = 1;
		else
			tree[num].numb = 1;
		return;
	}

	while (1) {
		cur = tree[cur].sufflink;
		curlen = tree[cur].len;
		if ((pos - 1 - curlen >= 0) && (s[pos - 1 - curlen] == s[pos])) {
			tree[num].sufflink = tree[cur].next[letter];
			break;
		}
	}
	if (ss == 1) {
		tree[num].numa = 1;
		tree[num].lazya++;
	}
	else  {		
		tree[num].numb = 1;
		tree[num].lazyb++;
	}

}

int cntb, cnte, cntl;

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int t;
	scanf("%d", &t);
	getchar();
	for (int i = 0; i < t; i++) {

		string s1;
		string s2;
		
		getline(cin, s1);
		getline(cin, s2);
		initTree(max(sz(s1), sz(s2)) + 2);
		ss = 1;
		s = s1;
		for (int j = 0; j < sz(s1); j++) {
			addLetter(j);
		}
		ss = 2;
		s = s2;
		for (int j = 0; j < sz(s2); j++)
			addLetter(j);
		
		for (int j = sz(s1) + 3; j >= 3; j--) {
			if (tree[j].sufflink > 2) {
				int sf = tree[j].sufflink;
				tree[sf].numa += tree[j].lazya;
				tree[sf].lazya += tree[j].lazya;
			}
		}
		for (int j = sz(s2) + 3; j >= 3; j--) {
			if (tree[j].sufflink > 2) {
				int sf = tree[j].sufflink;
				tree[sf].numb += tree[j].lazyb;
				tree[sf].lazyb += tree[j].lazyb;
			}
		}
		
		cntb = cnte = cntl = 0;
		

		queue <int> q;
		q.push(1);
		while(!q.empty()) {
			int v = q.front();
			q.pop();
			if ((v != 2) && (v != 1)) {
				if (tree[v].numa > tree[v].numb)
					cntb++;
				else if (tree[v].numa < tree[v].numb)
					cntl++;
				else
					cnte++;
			}
			for (int i = 0; i < 26; i++) 
				if(tree[v].next[i]) 
					q.push(tree[v].next[i]);
		}
		q.push(2);
		while(!q.empty()) {
			int v = q.front();
			q.pop();
			if ((v != 2) && (v != 1)) {
				if (tree[v].numa > tree[v].numb)
					cntb++;
				else if (tree[v].numa < tree[v].numb)
					cntl++;
				else
					cnte++;
			}
			for (int i = 0; i < 26; i++) 
				if(tree[v].next[i]) 
					q.push(tree[v].next[i]);
		}
		printf("Case #%d: %d %d %d\n", i + 1, cntb, cnte, cntl);
	}
	return 0;
}