#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

#define MAXN 301000
#define SIGMA 26
#define BASE 'a'
struct state {
    int len, link, to[SIGMA], cnt;
    int height;
};

struct palindromic_tree {
    int last, sz, n;
    char *s;
    state *st;
    palindromic_tree(char *_s, state *_st) : last(1), sz(2), n(0) {
        s = _s;
        st = _st;

        int maxn = strlen(s) + 100;
        memset(st, 0, maxn * sizeof(state));

        st[0].len = st[0].link = -1;
        st[1].len = st[1].link = 0;
    }
    int extend() {
        char c = s[n++];
        int p = last;
        while (n - st[p].len - 2 < 0 || c != s[n-st[p].len-2]) {
            p = st[p].link;
        }

        if (!st[p].to[c-BASE]) {
            int q = last = sz++;
            st[p].to[c-BASE] = q;
            st[q].len = st[p].len + 2;
            do {
                p = st[p].link;
            } while (p != -1 && (n < st[p].len + 2 || c != s[n-st[p].len-2]));

            if (p == -1) st[q].link = 1;
            else st[q].link = st[p].to[c-BASE];

            st[q].height = 1 + st[st[q].link].height;
            return 1;
        }

        last = st[p].to[c-BASE];
        return 0;
    }
};

int main() {

    char *s1 = new char[MAXN];
    char *s2 = new char[MAXN];

    state *st1 = new state[MAXN];
    state *st2 = new state[MAXN];

    scanf("%s\n", s1);

    int n1 = strlen(s1),
        n2 = n1;

    for (int i = 0; i < n1; i++) {
        s2[i] = s1[n1 - i - 1];
    }
    s2[n1] = 0;

    int *c1 = new int[n1];
    int *c2 = new int[n1];

    palindromic_tree t1(s1, st1);
    palindromic_tree t2(s2, st2);

    for (int i = 0; i < n1; i++) {
        t1.extend();
        c1[i] = t1.st[t1.last].height;
        //t1.st[t1.last].cnt++;
    }

    for (int i = 0; i < n2; i++) {
        t2.extend();
        c2[i] = t2.st[t2.last].height;
        //t2.st[t2.last].cnt++;
    }

    ll res = 0;
    for (int i = 1; i < n1; i++) {
        int j = n1 - i - 1;
        res += c1[i-1] * c2[j];
    }

    cout << res << endl;

    /*
    for (int at = 0; at < t1.sz; at++) {
        t1.st[t1.st[at].link].cnt += t1.st[at].cnt;
    }

    for (int at = 0; at < t2.sz; at++) {
        t2.st[t2.st[at].link].cnt += t2.st[at].cnt;
    }
    */

    return 0;
}

