
#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

//#define MAXN 100100
#define MAXN 50
#define SIGMA 2
#define BASE 'a'
char *s = new char[MAXN];
struct state {
    int len, link, to[MAXN];
} *st = new state[MAXN];

struct palindromic_tree {
    int last, sz, n;
    palindromic_tree() : last(1), sz(2), n(0) {
        st[0].len = st[0].link = -1;
        st[1].len = st[1].link = 0;
    }
    int extend() {
        char c = s[n++];
        int p = last;
        while (n - st[p].len - 2 < 0 || c != s[n-st[p].len-2]) {
            p = st[p].link;
        }

        if (!st[p].to[c-BASE]) {
            int q = last = sz++;
            st[p].to[c-BASE] = q;
            st[q].len = st[p].len + 2;
            do {
                p = st[p].link;
            } while (p != -1 && (n < st[p].len + 2 || c != s[n-st[p].len-2]));

            if (p == -1) st[q].link = 1;
            else st[q].link = st[p].to[c-BASE];

            return 1;
        }

        last = st[p].to[c-BASE];
        return 0;
    }
};


int n;
int cnt;
void bt(int at) {
    if (at == n) {
        /*
        for (int i = 0; i < n; i++) {
            cout << s[i];
        }
        */

        memset(st, 0, MAXN * sizeof(state));
        palindromic_tree t;
        int now = 0;
        for (int i = 0; i < n; i++) {
            now += t.extend();
        }

        if (now == n) {
            cnt++;
        }

        //cout << " " << now << endl;

        return;
    }

    s[at] = 'a';
    bt(at + 1);
    s[at] = 'b';
    bt(at + 1);
}

int arr[30] = {
    2,
    4,
    8,
    16,
    32,
    64,
    128,
    252,
    488,
    932,
    1756,
    3246,
    5916,
    10618,
    18800,
    32846,
    56704,
    96702,
    163184,
    272460,
    450586,
    738274,
    1199376,
    1932338,
    3089518,
    4903164
};

int main() {

    int n;
    scanf("%d\n", &n);
    for (int i = 1; i <= n; i++) {
        cout << arr[i-1] << endl;
    }

    /*
    for (n = 1; n <= 40; n++) {
        cnt = 0;
        bt(0);
        cout << n << " " << cnt << " " << ((1<<n) - cnt) << endl;
    }

*/

    return 0;
}
