#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

const int N = 1000 * 1000;
const int T = 26;

#define link _____________________link

int tsz, to[N][T], link[N], len[N], lst;
int depth[N];
int cnt[2][N];

int add_node() {
	forn(i, T)
		to[tsz][i] = -1;
	return tsz++;
}

void init() {
	tsz = 0;
	add_node();
	add_node();

	len[0] = -1;
	len[1] = 0;

	link[0] = -1;
	link[1] = 0;

	depth[0] = 0;
	depth[1] = 0;

	lst = 1;
}

void add_char(char* s, int pos) {
	int v = lst;

	while (s[pos - len[v] - 1] != s[pos])
		v = link[v];

	int& nv = to[v][ s[pos] - 'a' ];

	if (nv == -1) {
		nv = add_node();
		len[nv] = len[v] + 2;

		v = link[v];
		while (v != -1 && s[pos - len[v] - 1] != s[pos])
			v = link[v];

		if (v == -1)
			link[nv] = 1;
		else
			link[nv] = to[v][ s[pos] - 'a' ];

		depth[nv] = depth[ link[nv] ] + 1;
	}

	lst = nv;
}

char a[2][N];

void out_trie(int v, string s) {
	if (sz(s)) {
		printf("%s %d %d\n", s.c_str(), cnt[0][v], cnt[1][v]);
	}
	forn(i, 26) {
		int u = to[v][i];
		if (u != -1) {
			string pref = "";
			if (len[v] >= 0)
				pref = char(i + 'a');
			out_trie(u, pref + s + char(i + 'a'));
		}
	}
}

bool read() {
	if (scanf("%s", a[0]) <= 0)
		return false;
	return true;
}

void solve() {
	init();

	int n = strlen(a[0]);
	forn(i, n) {
		a[1][i] = a[0][n - 1 - i];
	}

	a[1][n] = 0;

	forn(t, 2) {
		lst = 1;
		forn(i, n) {
			add_char(a[t], i); 
			cnt[t][i] = depth[lst];
		}
	}

	reverse(cnt[1], cnt[1] + n);

	li res = 0;

	forn(i, n - 1) {
		res += li(cnt[0][i]) * li(cnt[1][i + 1]);
	}

	cout << res << endl;

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	assert(read());
	solve();

	return 0;
}