#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

const int N = 500 * 1000;
const int T = 26;

int tsz, to[N][T], link[N], len[N], lst;
int cnt[2][N];

int add_node() {
	forn(i, T)
		to[tsz][i] = -1;
	forn(i, 2)
		cnt[i][tsz] = 0;
	return tsz++;
}

void init() {
	tsz = 0;
	add_node();
	add_node();

	len[0] = -1;
	len[1] = 0;

	link[0] = -1;
	link[1] = 0;

	lst = 1;
}

void add_char(char* s, int pos) {
	int v = lst;

	while (s[pos - len[v] - 1] != s[pos])
		v = link[v];

	int& nv = to[v][ s[pos] - 'a' ];

	if (nv == -1) {
		nv = add_node();
		len[nv] = len[v] + 2;

		v = link[v];
		while (v != -1 && s[pos - len[v] - 1] != s[pos])
			v = link[v];

		if (v == -1)
			link[nv] = 1;
		else
			link[nv] = to[v][ s[pos] - 'a' ];
	}

	lst = nv;
}

char a[2][N];

void out_trie(int v, string s) {
	if (sz(s)) {
		printf("%s %d %d\n", s.c_str(), cnt[0][v], cnt[1][v]);
	}
	forn(i, 26) {
		int u = to[v][i];
		if (u != -1) {
			string pref = "";
			if (len[v] >= 0)
				pref = char(i + 'a');
			out_trie(u, pref + s + char(i + 'a'));
		}
	}
}

bool read() {
	forn(i, 2)
		if (scanf("%s", a[i]) <= 0)
			return false;
	return true;
}

void solve() {
	init();

	forn(t, 2) {
		lst = 1;
		int n = strlen(a[t]);
		forn(i, n) {
			add_char(a[t], i); 
			cnt[t][lst]++;
		}
	}

	for (int i = tsz - 1; i >= 0; --i)
		forn(t, 2)
			cnt[t][ link[i] ] += cnt[t][i];

	int res[3];
	forn(i, 3)
		res[i] = 0;

	forn(i, tsz) {
		if (i <= 1)
			continue;
		int v = 0;
		if (cnt[0][i] > cnt[1][i])
			v = -1;

		if (cnt[0][i] < cnt[1][i])
			v = +1;

		res[v + 1]++;
	}

	forn(i, 3) {
		if (i)
			printf(" ");
		printf("%d", res[i]);
	}

	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	forn(i, t) {
		printf("Case #%d: ", i + 1);
		assert(read());
		solve();
	}

	return 0;
}