#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define H 31
#define MOD 1234567891

using namespace std;
int T, na, nb, nr[2][400100], hashpart[400100], Put[400100], inv[400100];
char A[400100], B[400100];
long long sol[3];

struct Trie
{
    Trie *fiu[26], *fiustar;
    int fr;
    Trie()
    {
        fr = 0;
        memset(fiu, 0, sizeof(fiu));
        fiustar = 0;
    }
};
Trie *RA, *RB;
unordered_map <int, Trie * > Map;

inline int LgPut(int baz, int put)
{
    int rez = 1LL;
    while(put)
    {
        if(put % 2LL == 1LL)
        {
            rez = (1LL * rez * baz) % MOD;
            put--;
        }
        baz = (1LL * baz * baz) % MOD;
        put /= 2LL;
    }
    return rez;
}

inline void Manacher(int best[], char s[], int ns)
{
    int i, j, st, dr;
    best[1] = 1;
    best[2] = 2;
    st = 1;
    dr = 3;
    for(i = 3; i <= ns; ++i)
    {
        if(i > dr)
        {
            st = dr = i;
            best[i] = 0;
            while(st > 0 && dr <= ns && s[st] == s[dr])
            {
                best[i]++;
                st--;
                dr++;
            }
            st++;
            dr--;
            continue;
        }
        j = st + (dr - i);
        if(i + best[j] - 1 < dr)
        {
            best[i] = best[j];
            continue;
        }
        best[i] = dr + 1 - i;
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        best[i]--;
        while(st > 0 && dr <= ns && s[st] == s[dr])
        {
            best[i]++;
            st--;
            dr++;
        }
        st++;
        dr--;
    }
}

Trie * Build(int best[], char s[], int ns, Trie *R)
{
    int i, st, dr, hashnow, mij;
    bool ok;
    Trie *fiu, *tata, *bunic;
    for(i = 1; i <= ns; ++i)
        hashpart[i] = (1LL * hashpart[i - 1] + 1LL * Put[i] * s[i]) % MOD;
    for(i = 1; i <= ns; ++i)
    {
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        mij = (st + dr) / 2;
        hashnow = hashpart[mij] - hashpart[st - 1];
        if(hashnow < 0)
            hashnow += MOD;
        hashnow = (1LL * hashnow * inv[st]) % MOD;
        if(!Map[hashnow])
            Map[hashnow] = new Trie();
        fiu = Map[hashnow];
        fiu -> fr++;
        if(st == dr)
        {
            if(s[st] == '*')
                R -> fiustar = fiu;
            else
                R -> fiu[s[st] - 'a'] = fiu;
            continue;
        }
        dr--;
        st++;
        hashnow = hashpart[mij] - hashpart[st - 1];
        if(hashnow < 0)
            hashnow += MOD;
        hashnow = (1LL * hashnow * inv[st]) % MOD;
        ok = true;
        if(!Map[hashnow])
            Map[hashnow] = new Trie();
        else
            ok = false;
        tata = Map[hashnow];
        if(s[st - 1] == '*')
            tata -> fiustar = fiu;
        else
            tata -> fiu[s[st - 1] - 'a'] = fiu;
        while(ok)
        {
            fiu = tata;
            if(st == dr)
            {
                if(s[st] == '*')
                    R -> fiustar = fiu;
                else
                    R -> fiu[s[st] - 'a'] = fiu;
                ok = false;
                continue;
            }
            dr--;
            st++;
            hashnow = hashpart[mij] - hashpart[st - 1];
            if(hashnow < 0)
                hashnow += MOD;
            hashnow = (1LL * hashnow * inv[st]) % MOD;
            if(!Map[hashnow])
                Map[hashnow] = new Trie();
            else
                ok = false;
            tata = Map[hashnow];
            if(s[st - 1] == '*')
                tata -> fiustar = fiu;
            else
                tata -> fiu[s[st - 1] - 'a'] = fiu;
        }
    }
    return R;
}

Trie * Propaga(Trie *nod)
{
    if(nod == 0)
        return 0;
    int i;
    for(i = 0; i < 26; ++i)
    {
        if(nod -> fiu[i] != 0)
        {
            nod -> fiu[i] = Propaga(nod -> fiu[i]);
            nod -> fr += nod -> fiu[i] -> fr;
        }
    }
    if(nod -> fiustar != 0)
    {
        nod -> fiustar = Propaga(nod -> fiustar);
        nod -> fr += nod -> fiustar -> fr;
    }
    return nod;
}

Trie * Remove(Trie *nod)
{
    if(nod == 0)
        return 0;
    int i;
    for(i = 0; i < 26; ++i)
    {
        if(nod -> fiu[i] != 0)
        {
            nod -> fiu[i] = Remove(nod -> fiu[i]);
            delete (nod -> fiu[i]);
        }
    }
    if(nod -> fiustar != 0)
    {
        nod -> fiustar = Remove(nod -> fiustar);
        delete (nod -> fiustar);
    }
    return nod;
}

void DFS(Trie *R, int ind, bool permis)
{
    if(R == 0)
        return;
    if(permis && R -> fr > 0)
        sol[ind]++;
    int i;
    for(i = 0; i < 26; ++i)
        DFS(R -> fiu[i], ind, true);
    DFS(R -> fiustar, ind, false);
}

void Solve(Trie *R1, Trie *R2, bool permis)
{
    if(R1 == 0 || R2 == 0)
    {
        DFS(R1, 0, permis);
        DFS(R2, 2, permis);
        return;
    }
    int i;
    if(permis)
    {
        if(R1 -> fr < R2 -> fr)
            sol[2]++;
        if(R1 -> fr == R2 -> fr && R1 -> fr > 0)
            sol[1]++;
        if(R1 -> fr > R2 -> fr)
            sol[0]++;
    }
    for(i = 0; i < 26; ++i)
        Solve(R1 -> fiu[i], R2 -> fiu[i], true);
    Solve(R1 -> fiustar, R2 -> fiustar, false);
}

int main ()
{
#ifdef local
    freopen ("d.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, t, st, dr;
    cin >> T;
    Put[0] = 1;
    for(i = 1; i <= 400010; ++i)
        Put[i] = (1LL * H * Put[i - 1]) % MOD;
    i --;
    inv[i] = LgPut(Put[i], MOD - 2);
    for (i--; i >= 1; i --)
    {
        inv[i] = (1LL * inv[i + 1] * H) % MOD;
    }
    for(t = 1; t <= T; ++t)
    {
        cin >> (A + 1);
        cin >> (B + 1);
        na = strlen(A + 1);
        nb = strlen(B + 1);
        sol[0] = sol[1] = sol[2] = 0LL;
        Map.clear();
        A[2 * na + 1] = '*';
        for(i = 2 * na; i > 0; i -= 2)
        {
            A[i] = A[i / 2];
            A[i - 1] = '*';
        }
        na = 2 * na + 1;
        B[2 * nb + 1] = '*';
        for(i = 2 * nb; i > 0; i -= 2)
        {
            B[i] = B[i / 2];
            B[i - 1] = '*';
        }
        nb = 2 * nb + 1;
        for(i = 1; i <= na; ++i)
            nr[0][i] = 0;
        for(i = 1; i <= nb; ++i)
            nr[1][i] = 0;
        Manacher(nr[0], A, na);
        Manacher(nr[1], B, nb);
        RA = new Trie();
        RA = Build(nr[0], A, na, RA);
        Map.clear();
        RB = new Trie();
        RB = Build(nr[1], B, nb, RB);
        RA = Propaga(RA);
        RB = Propaga(RB);
        Solve(RA, RB, false);
        RA = Remove(RA);
        RB = Remove(RB);
        delete RA;
        delete RB;
        cout << "Case #" << t << ": " << sol[0] << ' ' << sol[1] << ' ' << sol[2] << "\n";
    }
    return 0;
}
