#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

int sol, n;
int v[40], best[82];
long long hashpart[82];
unordered_map <long long, bool> f[82];

inline void Manacher(int s[], int ns)
{
    int i, j, st, dr;
    best[1] = 1;
    best[2] = 2;
    st = 1;
    dr = 3;
    for(i = 3; i <= ns; ++i)
    {
        if(i > dr)
        {
            st = dr = i;
            best[i] = 0;
            while(st > 0 && dr <= ns && s[st] == s[dr])
            {
                best[i]++;
                st--;
                dr++;
            }
            st++;
            dr--;
            continue;
        }
        j = st + (dr - i);
        if(i + best[j] - 1 < dr)
        {
            best[i] = best[j];
            continue;
        }
        best[i] = dr + 1 - i;
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        best[i]--;
        while(st > 0 && dr <= ns && s[st] == s[dr])
        {
            best[i]++;
            st--;
            dr++;
        }
        st++;
        dr--;
    }
}

void rez (int n)
{
    int vv[82];
    int i, st, dr, nr = 0;
    long long now;
    for(i = 1; i <= 2 * n + 1; ++i)
        f[i].clear();
    vv[2 * n + 1] = 2;
    for(i = 2 * n; i > 0; i -= 2)
    {
        vv[i] = v[i / 2];
        vv[i - 1] = 2;
    }
    Manacher(vv, 2 * n + 1);
    for(i = 2; i <= 2 * n + 1; i += 2)
        hashpart[i] = hashpart[i - 2] + vv[i] * (1 << (i / 2));
    for(i = 1; i <= 2 * n + 1; ++i)
    {
        st = i - best[i] + 1;
        dr = i + best[i] - 1;
        st++;
        dr--;
        if(st > dr)
            continue;
        now = ((hashpart[dr] - hashpart[st - 2]) >> (st / 2));
        while(st <= dr && f[dr - st + 1][now] == false)
        {
            nr++;
            f[dr - st + 1][now] = true;
            st += 2;
            dr -= 2;
            if(st <= dr)
                now = ((hashpart[dr] - hashpart[st - 2]) >> (st / 2));
        }
        if(nr > n)
            return;
    }
    if(nr == n)
        sol++;
}

int solf[] = {0, 1, 2, 4, 8, 16, 32, 64, 128, 252, 488, 932, 1756, 3246, 5916, 10618, 18800, 32846, 56704, 96702, 163184, 272460, 450586, 738274, 1199376, 1932338, 3089518, 4903164};

int main ()
{
#ifdef local
    freopen ("e.in", "r", stdin);
    freopen ("e.out", "w", stdout);
#endif

    scanf ("%d", &n);
    /*
    int st, lim = (1 << n) - 1;

    for (st = 0; st <= lim; st ++)
    {
        int i, j;
        for (i = 1; i <= n; i ++)
            v[i] = !!(st & (1 << (i - 1)));
        rez (n);
    }
    printf ("%d\n", sol);
    */
    int i;
    for (i = 1; i <= n; i ++)
        printf ("%d\n", solf[i]);
    return 0;
}
