#include <iostream>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

struct Node {
	int len;
	char c;
	int suffix;
	int suffcount;
	int child[26];
};

Node nodes[500005];
int nodecount = 0;
int n;
string S;

int getSuffcount(int node) {
	if(node <= 1) return 0;
	if(nodes[node].suffcount == 0) {
		nodes[node].suffcount = getSuffcount(nodes[node].suffix) + 1;
	}
	return nodes[node].suffcount;
}

int L[500005];
int R[500005];

int main() {
	fill((char*)nodes, (char*)nodes + 500005 * sizeof(Node), 0);

	nodecount = 2;
	nodes[0].len = -1;
	nodes[0].c = '\0';
	nodes[0].suffix = 0;
	nodes[1].len = 0;
	nodes[1].c = '\0';
	nodes[1].suffix = 0;

	cin.sync_with_stdio(false);
	cin >> S;
	n = S.size();
	
	int node = 1;
	L[0] = node;
	for(int i = 0; i < n; ++i) {
		int innode = node;
		while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
			innode = nodes[innode].suffix;
		}
		if(nodes[innode].child[S[i] - 'a']) {
			node = nodes[innode].child[S[i] - 'a'];
		} else {
			int newnode = nodecount++;
			nodes[innode].child[S[i] - 'a'] = newnode;
			nodes[newnode].len = nodes[innode].len + 2;
			nodes[newnode].c = S[i];
			
			if(nodes[newnode].len == 1) {
				nodes[newnode].suffix = 1;
			} else {
				innode = nodes[innode].suffix;
				while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
					innode = nodes[innode].suffix;
				}
				nodes[newnode].suffix = nodes[innode].child[S[i] - 'a'];
			}
			
			node = newnode;
		}
		
/*		cout << i << " L:\n";
		int x = node;
		while(x != 1) {
			cout << " " << nodes[x].len << " (" << x << ")\n";
			x = nodes[x].suffix;
		}
*/		
		L[i + 1] = node;
	}
	
	node = 1;
	R[n] = node;
	reverse(S.begin(), S.end());
	for(int i = 0; i < n; ++i) {
		int innode = node;
		while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
			innode = nodes[innode].suffix;
		}
		if(nodes[innode].child[S[i] - 'a']) {
			node = nodes[innode].child[S[i] - 'a'];
		} else {
			int newnode = nodecount++;
			nodes[innode].child[S[i] - 'a'] = newnode;
			nodes[newnode].len = nodes[innode].len + 2;
			nodes[newnode].c = S[i];
			
			if(nodes[newnode].len == 1) {
				nodes[newnode].suffix = 1;
			} else {
				innode = nodes[innode].suffix;
				while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
					innode = nodes[innode].suffix;
				}
				nodes[newnode].suffix = nodes[innode].child[S[i] - 'a'];
			}
			
			node = newnode;
		}
		
		R[n - 1 - i] = node;
	}
	
	int64_t ret = 0;
	for(int i = 1; i < n; ++i) {
		ret += (int64_t)getSuffcount(L[i]) * (int64_t)getSuffcount(R[i]);
	}
	cout << ret << "\n";
	
	return 0;
}
