#include <iostream>
#include <string>
#include <algorithm>
#include <cassert>

using namespace std;

struct Node {
	int len;
	char c;
	int suffix;
	int64_t counts[2];
	int child[26];
};

Node nodes[500005];
int nodecount;

void compute(string& S, int c) {
	int n = S.size();
	int node = 1;
	for(int i = 0; i < n; ++i) {
		int innode = node;
		while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
			innode = nodes[innode].suffix;
		}
		if(nodes[innode].child[S[i] - 'a']) {
			node = nodes[innode].child[S[i] - 'a'];
		} else {
			int newnode = nodecount++;
			nodes[innode].child[S[i] - 'a'] = newnode;
			nodes[newnode].len = nodes[innode].len + 2;
			nodes[newnode].c = S[i];
			
			if(nodes[newnode].len == 1) {
				nodes[newnode].suffix = 1;
			} else {
				innode = nodes[innode].suffix;
				while(i - 1 - nodes[innode].len < 0 || S[i - 1 - nodes[innode].len] != S[i]) {
					innode = nodes[innode].suffix;
				}
				nodes[newnode].suffix = nodes[innode].child[S[i] - 'a'];
			}
			
			node = newnode;
		}
		++nodes[node].counts[c];
	}
}



int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
	for(int te = 0; te < Te; ++te) {
		string A, B;
		cin >> A >> B;
		
		fill((char*)nodes, (char*)(nodes + A.size() + B.size() + 5), 0);
		
		nodecount = 2;
		nodes[0].len = -1;
		nodes[0].c = '\0';
		nodes[0].suffix = 0;
		nodes[1].len = 0;
		nodes[1].c = '\0';
		nodes[1].suffix = 0;
		
		compute(A, 0);
		compute(B, 1);
		
		for(int i = nodecount - 1; i >= 2; --i) {
		for(int c = 0; c < 2; ++c) {
			nodes[nodes[i].suffix].counts[c] += nodes[i].counts[c];
		}
		}
		
		int a = 0;
		int b = 0;
		int c = 0;
		for(int i = 2; i < nodecount; ++i) {
			int64_t c0 = nodes[i].counts[0];
			int64_t c1 = nodes[i].counts[1];
			if(c0 == c1) {
				++b;
			} else if(c0 < c1) {
				++c;
			} else {
				++a;
			}
		}
		
		cout << "Case #" << te + 1 << ": " << a << " " << b << " " << c << "\n";
	}
	
	
	return 0;
}
