#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <queue>

#define MAX_NODES_IN_PTREE 200003
#define oeis 26

typedef long long ll;
typedef long double ld;

using namespace std;

ll ats = 0;

struct node {
	int next[26], len, sufflink, num;
};

string s; // input string
int suff = 1, num = 2; // unknown

node tree[MAX_NODES_IN_PTREE]; // palindromic tree for input string

void init() {
	memset(tree, 0, num*sizeof(node));
	tree[1].len = -1;
	tree[2].len = 0;

	tree[1].num = tree[2].num = 0;

	tree[1].sufflink = tree[2].sufflink = 1;
}

bool add(int pos) {
	int cur = suff, curlen = 0;
	int let = s[pos] - 'a';
	while (true) {
		curlen = tree[cur].len;
		if (pos - 1 - curlen >= 0 && s[pos - 1 - curlen] == s[pos])
			break;
		cur = tree[cur].sufflink;
	}
	if (tree[cur].next[let]) {
		suff = tree[cur].next[let];
		return false;
	}
	num++;
	suff = num;
	tree[num].len = tree[cur].len + 2;
	tree[cur].next[let] = num;
	if (tree[num].len == 1) {
		tree[num].sufflink = 2;
		tree[num].num = 1;
		return true;
	}
	while (true) {
		cur = tree[cur].sufflink;
		curlen = tree[cur].len;
		if (pos - 1 - curlen >= 0 && s[pos - 1 - curlen] == s[pos]) {
			tree[num].sufflink = tree[cur].next[let];
			break;
		}
	}

	tree[num].num = 1 + tree[tree[num].sufflink].num;
	return true;
}

void generate (string curS)
{
	//cout << curS << endl;
	if (curS.length() < oeis)
	{
		generate(curS+'a');
		generate(curS+'b');
	} else if (curS.length() == oeis)
	{
		init();
		num = 2;
		suff = 1;
		s = curS;


		for (size_t i = 0; i < s.length(); ++i)
		{
		//	cout << "adding " << s[i] << endl;
			add(i);
		}

		if (num - 2 == oeis)
			ats++;
	}
}

int goodAns[] = {0, 2, 4, 8, 16, 32, 64, 128, 252, 488,
	932, 1756, 3246, 5916, 10618, 18800, 32846, 56704, 96702, 163184, 272460, 450586, 738274, 1199376, 1932338, 3089518, 4903164}; 

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	//generate(string(""));
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
		cout << goodAns[i] << endl;

	//cout << ats << endl;
	
	//while (true);
	return 0;
}