#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

const int maxn = 3e5 + 100;
int d1[maxn], d2[maxn];
int n;
char s[maxn];

// MANA INIT
void init()
{
    d1[0] = 1;
    for (int i = 1, l = 0, r = -1; i < n; i++)
    {
        d1[i] = 1;
        if (i <= r)
            d1[i] = min(r - i + 1, d1[l + r - i]);
        while (i + d1[i] < n && i - d1[i] >= 0 && s[i - d1[i]] == s[i + d1[i]])
            d1[i]++;
        if (i + d1[i] - 1 > r)
            r = i + d1[i] - 1, l = i - d1[i] + 1;
    }

    for (int i = 1, l = 0, r = -1; i < n; i++)
    {
        if (i <= r)
            d2[i] = min(r - i, d2[l + r - i + 1]);

        while (i + d2[i] < n && i - d2[i] - 1 >= 0 && s[i - d2[i] - 1] == s[i + d2[i]])
            d2[i]++;
        if (i + d2[i] - 1 > r)
            r = i + d2[i] - 1, l = i - d2[i];
    }
}

void add(int *a, int l, int r)
{
    a[l]++;
    a[r + 1]--;
}

void process(int *a)
{
    int cur = 0;
    forn(i, maxn - 4)
    {
        cur += a[i];
        a[i] = cur;
    }
}

int start[maxn];
int finish[maxn];

void solve()
{
    gets(s);
    n = strlen(s);

    init();

    forn(i, n)
    {
        add(start, i - d1[i] + 1, i);
        add(start, i - d2[i], i - 1);
        add(finish, i, i + d1[i] - 1);
        add(finish, i, i + d2[i] - 1);
    }
    process(start);
    process(finish);

    LL res = 0;
    for (int i = 0; i < maxn - 10; ++i)
        res += LL(finish[i]) * start[i + 1];

    cout << res << endl;
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif