#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"
#define MAXN 200200

struct node{
    int l, suf, cnt;
    int cnt1, cnt2;
    int next[28];
};

char a[2 * MAXN], b[MAXN];
vector<node> ptree;
LL resa, resb, resc;
int n;

void readin(){
    gets(a);
    gets(b);
}

void build(char* s){
    node x;
    x.l = -1; x.suf = 0;
    memset(x.next, 0, sizeof(x.next));
    ptree.push_back(x);
    x.l = 0; x.suf = 0;
    memset(x.next, 0, sizeof(x.next));
    ptree.push_back(x);

    int suffix = 1;
    int cnt = 2;

    int l = strlen(s);
    for (int i = 0; i < l; i++){

        if (i == n){
            for (int i = cnt - 1; i > 1; i--){
                ptree[i].cnt1 += ptree[i].cnt;
                ptree[ptree[i].suf].cnt1 += ptree[i].cnt1;
            }
        }

        int cur = suffix;
        int ch;
        if (s[i] == '$') ch = 26;
        else if (s[i] == '#') ch = 27;
        else ch = s[i] - 'a';

        while (true){
            if (i - ptree[cur].l - 1 >= 0 && s[i - ptree[cur].l - 1] == s[i]) break;
            cur = ptree[cur].suf;
        }

        if (ptree[cur].next[ch]){
            suffix = ptree[cur].next[ch];
            ptree[ptree[cur].next[ch]].cnt++;
            continue;
        }
        
        node x;
        x.l = ptree[cur].l + 2;
        x.cnt = 1;
        x.cnt1 = 0;
        x.cnt2 = 0;
        memset(x.next, 0, sizeof(x.next));
        ptree.push_back(x);
        cnt++;
        suffix = cnt - 1;
        ptree[cur].next[ch] = cnt - 1;


        if (ptree[cnt - 1].l == 1){
            ptree[cnt - 1].suf = 1;
            ptree[cnt - 1].cnt = 1;
            continue;
        }

        while (true){
            cur = ptree[cur].suf;
            if (i - ptree[cur].l - 1 >= 0 && s[i - ptree[cur].l - 1] == s[i]) break;
        }

        ptree[cnt - 1].suf = ptree[cur].next[ch];

    }

    resa = 0; resb = 0; resc = 0;
    for (int i = cnt - 1; i > 1; i--){
        ptree[i].cnt2 += ptree[i].cnt;
        ptree[ptree[i].suf].cnt2 += ptree[i].cnt2;

        if (ptree[i].cnt1 * 2 > ptree[i].cnt2) resa++;
        if (ptree[i].cnt1 * 2 == ptree[i].cnt2) resb++;
        if (ptree[i].cnt1 * 2 < ptree[i].cnt2) resc++;
    }
    resc -= 2;
}

void init(){
    ptree.clear();
}

void process(){
    n = strlen(a);
    strcat(a, "#$");
    strcat(a, b);
    build(a);
}

void solve(){
    int test;
    scanf("%d", &test);
    char buf[30];
    gets(buf);
    for (int i = 1; i <= test; i++){
        readin();
        init();
        process();
        printf("Case #%d: %lld %lld %lld\n", i, resa, resb, resc);
    }
}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif